import umachine


class Dialog:
    def __init__(self, x, y, width, height, lines):
        self.x = x
        self.y = y
        self.width = width
        self.height = height
        self.lines = lines
        
        self.cur_line = 0
    
    def show_line(self):
        # TODO: automagically add linebreaks
        if self.cur_line < len(self.lines):
            if self.lines[self.cur_line]: # not None
                # line format: (color, text)
                umachine.draw_text(self.x, self.y, self.lines[self.cur_line][1], self.lines[self.cur_line][0])
            return True
        return False # dialog is done.
    
    def increase(self):
        self.cur_line += 1
        if self.cur_line < len(self.lines):
            return self.lines[self.cur_line] is not None
        return False

# 9  - johnny (blue)
# 4  - evilguy (red)
# 14 - guy (yellow)
# 8  - nanji (awesome purple)

# Maximum line length is this..\n
# Line 2
# Line 3
INTRO_DLG = (
    (9, "Hi, I'm Johnny from the\nmarketing department of Cat\nFood Inc."),
    (14, "Hello..\n"),
    (9, "We are making a promo video\nfor our latest brands of cat\nfoods:"),
    (9, "Spicey Mice & Airborn Tunas!"),
    (9, "And we want YOUR cat, Nanji,\nto starr in this video!"),
    (14, "Um.. What?"),
    (9, "Congratulations!\nYou'll be paid in cash.."),
    (9, "And Nanji will get a lifetime\nsupply of Cat Food(TM)."),
    (14, "But Nanji only eats food from\nKitten Meal Corp(TM)..."),
    (9, "..."),
    (14, "I mean.. Sorry, I'm not\ninterested in your offer."),
    (9, "Oh, really? Too bad. Have a\nnice day, then."),
    (9, "(... You'll regret this.)" ),
    None,
    (14, "Nanji?! Noooo!!"),
    None,
    (14, "I will rescue you, Nanji!"),
)