# Copyright (C) 2019 
#
# The source code in this file is released under the GPLv3.
# Go to https://www.gnu.org/licenses/gpl.txt for the full license details.
#
import upygame as pygame
import urandom as random
import umachine

import res
import maps
from states import *


# Set palette
pygame.display.set_palette_16bit([
    0, 6438, 18917, 10825, 47398, 688, 41764, 17475,
    0xdc9c, 13598, 60486, 40179, 42596, 0xd6fb, 63245, 65535
]);



GO_START = 0
GO_LEVELS = 1
GO_INTRO = 2
GO_OUTRO = 3
GO_CATSCENE = 42


def level_loop(screen):
    level_idx = 0
    while level_idx < len(maps.levels):
        cur_level = maps.levels[level_idx]
        state = MapState(screen, cur_level.width, cur_level.height, cur_level.map_data)
        exit_status = state.mainloop()
        if exit_status == 0:
            if level_idx == 6: # last storage level
                state = CatScene(screen) # show cutscene
                state.mainloop()
            level_idx += 1  # load next level
        elif exit_status == 1:
            break # goto start menu
        
        # else repeat level again
    if level_idx == len(maps.levels):
        return 3
    return 0
    
# start game
def main():
    pygame.display.init()
    screen = pygame.display.set_mode()
    exit_status = GO_START
    #exit_status = GO_OUTRO
    #exit_status = GO_INTRO
    #exit_status = GO_LEVELS
    #exit_status = GO_CATSCENE
    # state engine loop
    while True:
        if exit_status == GO_OUTRO:
            state = OutroScreen(screen)
            state.mainloop()
            exit_status = 0
        elif exit_status == GO_LEVELS:
            exit_status = level_loop(screen)
        elif exit_status == GO_INTRO:
            state = IntroScreen(screen)
            state.mainloop()
            exit_status = GO_LEVELS
        elif exit_status == GO_CATSCENE:
            state = CatScene(screen)
            state.mainloop()
            exit_status = 0
        else:
            state = StartScreen(screen)
            state.mainloop()
            exit_status = GO_INTRO

main()